#!/bin/tclsh

load tclrega.so
source /usr/local/addons/weather/weatherini.tcl


# ----------------------------------- Prodzeduren --------------------------------------------------------------------------------------------------------------

proc getb {idx} {
   global answer
   set sb [string index $answer $idx]
   scan $sb %c ascii
   return $ascii
}

proc getw {idx} {
   global answer
   set sb [string index $answer $idx]
   scan $sb %c asciih
   set idx [expr $idx + 1]
   set sb [string index $answer $idx]  
   scan $sb %c asciil
   set zahl [expr $asciil + { $asciih * 256}]
   return $zahl
} 

proc getl {idx} {
   global answer
   set sb [string index $answer $idx]
   scan $sb %c ascii3
   set idx [expr $idx + 1]
   set sb [string index $answer $idx]  
   scan $sb %c ascii2
   set idx [expr $idx + 1]
   set sb [string index $answer $idx]  
   scan $sb %c ascii1   
   set idx [expr $idx + 1]
   set sb [string index $answer $idx]  
   scan $sb %c ascii0   
   set zahl [expr $ascii0 + {$ascii1 * 256} + {$ascii2 * 65536} + {$ascii3 * 16777216}]
   return $zahl
}

proc get_mac {} {
	global ip_address
   set status [catch {exec ping -w1 -t1 $ip_address} result]
	set fp [open "/proc/net/arp" r]
	set file_data [read $fp]
	set data [split $file_data "\n"]
	foreach line $data {
		regexp {^([\d\.]+)\s+\S+\s+\S+\s+([0-9a-f:]+)\s+} $line match ip mac
		if { [info exists ip] } {
			if {$ip == $ip_address && $mac != "00:00:00:00:00:00"} {
				set mac_address $mac
			}
		}
	}
	close $fp
   return $mac_address
}

proc checksum {bin_str} {
   set bb 0
   set xx 0
   for {set i 2} {$i < 81} {incr i} {set xx [expr $xx + [getb $i]]}
   set xx [expr $xx & 255]
   if {$xx == [getb 81]} { set bb 1 }
   return $bb
}

# ---------------------------------- Hauptprogramm -------------------------------------------------------------------------------------------------------------
# *** Daten von Wetterstation holen und nach answer schreiben (String von 82 Byte Länge)

 	set ip_address 192.168.0.129
   set ip_port 45000
	
   # set mac_address [get_mac] ;  # nur zum Test, kann man schauen ob ping geht und die MAC Addresse der Wetterstation prüfen
   # puts $mac_address
  
   # Input / Output für socat über Files - wenn das jemand anders hinbekommt melden! Habe raspberry 3, da scheint es kein funktionierendes netcat (nc) zu geben
   catch {exec /usr/local/addons/cuxd/extra/socat open:/usr/local/addons/weather/weather.hexin,ignoreeof!!create:/var/weather.hexout TCP:$ip_address:$ip_port,readbytes=82,connect-timeout=3} msg
	set fp [open "/var/weather.hexout" r]
	set answer [read $fp] ;                 # answer ist Global, enthält ab hier den Binärstring der Rückgabe der Wetterstation
   close $fp

   set itemp [expr double([getw $in_temperature]) / 10]
   set atemp [expr double([getw $out_temperature]) / 10]
   set dewpt [expr double([getw $dewpoint]) / 10]
   set windc [expr double([getw $windchill]) / 10]
   set heati [expr double([getw $heatindex]) / 10]
   set hum_i [getb $in_humidity]
   set hum_a [getb $out_humidity]
   set apres [expr double([getw $abs_pressure]) / 10]
   set rpres [expr double([getw $rel_pressure]) / 10]   
   set w_dir [getw $wind_direction]
   set w_spe [getw $wind_speed]   
   set w_gus [getw $gust_speed]  
   set rainh [expr double([getl $rain_hour]) / 10]
   set raind [expr double([getl $rain_day]) / 10]
   set rainw [expr double([getl $rain_week]) / 10]
   set rainm [expr double([getl $rain_month]) / 10]
   set rainy [expr double([getl $rain_year]) / 10]
   set raint [expr double([getl $rain_total]) / 10]
   set l_lux [expr double([getl $light]) / 10000]
   set uvrad [expr double([getw $uv_radiation]) / 10]
   set uvidx [getb $uv_index]
   set check [checksum $answer]

   # Das habe ich mit switch nicht hinbekommen !!! kennt kein kleiner als als Vergleichsmuster ?!
   if [expr $w_dir <= 360]   {set windrichtung N}
   if [expr $w_dir <= 348]   {set windrichtung NNW}    
   if [expr $w_dir <= 326]   {set windrichtung NW}    
   if [expr $w_dir <= 303]   {set windrichtung NWW}    
   if [expr $w_dir <= 281]   {set windrichtung W}    
   if [expr $w_dir <= 258]   {set windrichtung SWW}    
   if [expr $w_dir <= 236]   {set windrichtung SW}
   if [expr $w_dir <= 213]   {set windrichtung SSW}
   if [expr $w_dir <= 191]   {set windrichtung S}
   if [expr $w_dir <= 168]   {set windrichtung SSO}
   if [expr $w_dir <= 146]   {set windrichtung SO}
   if [expr $w_dir <= 123]   {set windrichtung SOO}
   if [expr $w_dir <= 101]   {set windrichtung O}
   if [expr $w_dir <= 78]    {set windrichtung NOO}
   if [expr $w_dir <= 56]    {set windrichtung NO}
   if [expr $w_dir <= 33]    {set windrichtung NNO}
   if [expr $w_dir <= 11]    {set windrichtung N}
   append windrichtung " - $w_dir"

#- ab hier werden die Variablen "gefüllt"

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS__check');"
	append isecmd "x.State('"
	append isecmd $check
	append isecmd "');"
	rega_script $isecmd

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Innentemperatur');"
	append isecmd "x.State('"
	append isecmd $itemp
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Aussentemperatur');"
	append isecmd "x.State('"
	append isecmd $atemp
	append isecmd "');"
	rega_script $isecmd

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Taupunkt');"
	append isecmd "x.State('"
	append isecmd $dewpt
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Windchill');"
	append isecmd "x.State('"
	append isecmd $windc
	append isecmd "');"
	rega_script $isecmd

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Hitzeindex');"
	append isecmd "x.State('"
	append isecmd $heati
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Luftfeuchte_Innen');"
	append isecmd "x.State('"
	append isecmd $hum_i
	append isecmd "');"
	rega_script $isecmd

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Luftfeuchte_Aussen');"
	append isecmd "x.State('"
	append isecmd $hum_a
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Luftdruck_absolut');"
	append isecmd "x.State('"
	append isecmd $apres
	append isecmd "');"
	rega_script $isecmd   

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Luftdruck_relativ');"
	append isecmd "x.State('"
	append isecmd $rpres
	append isecmd "');"
	rega_script $isecmd

   #append $windrichtung ""
   set isecmd
	append isecmd "var x = dom.GetObject('WS_Windrichtung');"
	append isecmd "x.State('"
   append isecmd $windrichtung
	append isecmd "');"
	rega_script $isecmd

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Windgeschwindigkeit');"
	append isecmd "x.State('"
	append isecmd $w_spe
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Windboe');"
	append isecmd "x.State('"
	append isecmd $w_gus
	append isecmd "');"
	rega_script $isecmd

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Regen_Stunde');"
	append isecmd "x.State('"
	append isecmd $rainh
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Regen_Tag');"
	append isecmd "x.State('"
	append isecmd $raind
	append isecmd "');"
	rega_script $isecmd

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Regen_Woche');"
	append isecmd "x.State('"
	append isecmd $rainw
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Regen_Monat');"
	append isecmd "x.State('"
	append isecmd $rainm
	append isecmd "');"
	rega_script $isecmd   
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Regen_Jahr');"
	append isecmd "x.State('"
	append isecmd $rainy
	append isecmd "');"
	rega_script $isecmd

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Regen_Total');"
	append isecmd "x.State('"
	append isecmd $raint
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Sonne_Helligkeit');"
	append isecmd "x.State('"
	append isecmd $l_lux
	append isecmd "');"
	rega_script $isecmd   

	set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Sonne_UV');"
	append isecmd "x.State('"
	append isecmd $uvrad
	append isecmd "');"
	rega_script $isecmd
   
   set isecmd ""
	append isecmd "var x = dom.GetObject('WS_Sonne_UV_Index');"
	append isecmd "x.State('"
	append isecmd $uvidx
	append isecmd "');"
	rega_script $isecmd 